<template>
  <div class="component-container">
    <lenna-modal ref="lennaModal"></lenna-modal>
    <lenna-loading v-show="isLoading"></lenna-loading>

    <h3 class="text-primary">Integrate with your own Apps</h3>
    <hr>
    <form @submit.prevent="submitForm">
      <div class="form-group">
        <span class="text-muted">Fill your credentials below</span>
      </div>

      <div class="form-group row">
        <div class="col-md-12">
          <strong class="d-block">FCM Server Key</strong>
        </div>
        <div class="col-sm-12">
          <input type="text" class="form-control" id="logout-url" v-model="form.serverKey">
          <small class="d-block">This url used for send and broadcasting message</small>
        </div>
      </div>
      <div class="form-group">
        <span class="text-muted">Copy these webhook URL andd paste it as your application endpoint.</span>
      </div>
      <div class="form-group row">
        <div class="col-md-12">
          <strong class="d-block">Chat URL</strong>
          <small class="d-block">This url used for chat</small>
        </div>

        <div class="col-sm-10">
          <input type="text" class="form-control" id="chat-url" v-model="chatUrl" readonly>
        </div>
        <div class="col-sm-2">
          <button class="btn h-100 btn-rounded btn-primary" @click.prevent="handleCopy">Copy</button>
        </div>
      </div>
      <div class="form-group row">
        <div class="col-md-12">
          <strong class="d-block">Register URL</strong>
          <small class="d-block">This url used for register</small>
        </div>
        <div class="col-sm-10">
          <input type="text" class="form-control" id="register-url" v-model="registerUrl" readonly>
        </div>
        <div class="col-sm-2">
          <button class="btn h-100 btn-rounded btn-primary" @click.prevent="handleCopy">Copy</button>
        </div>
      </div>
      <div class="form-group row">
        <div class="col-md-12">
          <strong class="d-block">Login URL</strong>
          <small class="d-block">This url used for login</small>
        </div>
        <div class="col-sm-10">
          <input type="text" class="form-control" id="login-url" v-model="loginUrl" readonly>
        </div>
        <div class="col-sm-2">
          <button class="btn h-100 btn-rounded btn-primary" @click.prevent="handleCopy">Copy</button>
        </div>
      </div>

      <div class="form-group row">
        <div class="col-md-12">
          <strong class="d-block">Logout URL</strong>
          <small class="d-block">This url used for logout</small>
        </div>
        <div class="col-sm-10">
          <input type="text" class="form-control" id="logout-url" v-model="logoutUrl" readonly>
        </div>
        <div class="col-sm-2">
          <button class="btn h-100 btn-rounded btn-primary" @click.prevent="handleCopy">Copy</button>
        </div>
      </div>
      <div class="form-group row">
        <input type="hidden" v-model="form.status">
        <div class="col-sm-6">
          <button
            type="button"
            class="btn btn-rounded btn-block"
            :class="(!form.status) ? 'btn-secondary': 'btn-danger'"
            :disabled="!form.status"
            @click="disconnectChannel"
          >Disconnect</button>
        </div>
        <div class="col-sm-6">
          <button
            type="submit"
            class="btn btn-rounded btn-block btn-primary"
          >{{(form.status) ? 'Update': 'Connect'}}</button>
        </div>
      </div>
    </form>
  </div>
</template>
<script>
import EventBus from "@/EventBus.js";

export default {
  data() {
    return {
      form: {
        channelName: "mobile",
        serverKey: "",
        status: false
      },
      loginUrl: "",
      logoutUrl: "",
      registerUrl: ""
    };
  },
  computed: {
    chatUrl() {
      return (
        this.baseUrl +
        "/api/" +
        this.$store.getters.appId.hashed +
        "/webhook/mobile"
      );
    },
    isLoading() {
      return this.$store.getters.isLoading;
    }
  },
  methods: {
    async disconnectChannel() {
      try {
        let data = {
          channelName: this.form.channelName,
          status: false
        };
        let response = await this.$axios.put(
          `api/${this.$store.getters.appId.hashed}/integrate/update`,
          data
        );
        response = response.data;

        this.$refs.lennaModal.show("info", "Success", response.message);

        this.form.status = false;
        EventBus.$emit("toggleStatusMain", "mobile");
      } catch (error) {
        this.form.status = !this.form.status;
        this.$refs.lennaModal.show(
          "alert",
          "Sorry",
          error.response.data.message
        );
      }
    },
    async submitForm() {
      try {
        let formData = { ...this.form, status: true };
        let response = await this.$axios.post(
          `api/${this.$store.getters.appId.hashed}/integrate`,
          formData
        );
        this.form.status = true;

        this.$refs.lennaModal.show("info", "Success", response.data.message);

        EventBus.$emit("toggleStatusMain", "mobile");
      } catch (error) {
        this.$refs.lennaModal.show("alert", "Error", "Something wrong!");
      }
    },
    async fetchData() {
      let response = await this.$axios.get(
        `api/${this.$store.getters.appId.hashed}/integrate`
      );
      response = response.data;
      let channelData = response.data.find(function(item) {
        return item.name == "mobile";
      }).integration;

      if (channelData != null) {
        this.form.serverKey = channelData.integration_data.serverKey;
        this.form.status = channelData.status;
      }
    }
  },
  async mounted() {
    this.fetchData();
    EventBus.$on("toggleStatus", value => {
      this.fetchData();
    });
  }
};
</script>
<style lang="scss">
</style>
